var _reactUiAriaInteractions = require("@react-ui-aria/interactions");

var _reactUiAriaFocus = require("@react-ui-aria/focus");

var _reactUiAriaUtils = require("@react-ui-aria/utils");

var _babelRuntimeHelpersExtends = require("@babel/runtime/helpers/extends");

var _babelRuntimeHelpersInteropRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
// ASSET: /home/cong/Github/ladifire/ladifire-ui-react/packages/@react-ui-aria/button/src/useButton.ts
var $b75e7ed18f914c4039a9fb9f9d6c7a34$exports = {};
var $b75e7ed18f914c4039a9fb9f9d6c7a34$var$_interopRequireDefault = _babelRuntimeHelpersInteropRequireDefault;
Object.defineProperty($b75e7ed18f914c4039a9fb9f9d6c7a34$exports, "__esModule", {
  value: true
});
var $b75e7ed18f914c4039a9fb9f9d6c7a34$export$useButton = $b75e7ed18f914c4039a9fb9f9d6c7a34$var$useButton;
$b75e7ed18f914c4039a9fb9f9d6c7a34$exports.useButton = $b75e7ed18f914c4039a9fb9f9d6c7a34$export$useButton;
var $b75e7ed18f914c4039a9fb9f9d6c7a34$var$_extends2 = $b75e7ed18f914c4039a9fb9f9d6c7a34$var$_interopRequireDefault(_babelRuntimeHelpersExtends);
var $b75e7ed18f914c4039a9fb9f9d6c7a34$var$_utils = _reactUiAriaUtils;
var $b75e7ed18f914c4039a9fb9f9d6c7a34$var$_focus = _reactUiAriaFocus;
var $b75e7ed18f914c4039a9fb9f9d6c7a34$var$_interactions = _reactUiAriaInteractions;

/*
 * Copyright 2020 Ladifire. All rights reserved.
 * This file is licensed to you under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. You may obtain a copy
 * of the License at http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS
 * OF ANY KIND, either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */

/**
 * Provides the behavior and accessibility implementation for a button component. Handles mouse, keyboard, and touch interactions,
 * focus behavior, and ARIA props for both native button elements and custom element types.
 * @param props - Props to be applied to the button.
 * @param ref - A ref to a DOM element for the button.
 */
function $b75e7ed18f914c4039a9fb9f9d6c7a34$var$useButton(props, ref) {
  let {
    elementType = 'button',
    isDisabled,
    onPress,
    onPressStart,
    onPressEnd,
    onPressChange,
    // @ts-ignore
    onClick: deprecatedOnClick,
    href,
    target,
    rel,
    type = 'button'
  } = props;
  let additionalProps;

  if (elementType !== 'button') {
    additionalProps = {
      role: 'button',
      tabIndex: isDisabled ? undefined : 0,
      href: elementType === 'a' && isDisabled ? undefined : href,
      target: elementType === 'a' ? target : undefined,
      type: elementType === 'input' ? type : undefined,
      disabled: elementType === 'input' ? isDisabled : undefined,
      'aria-disabled': !isDisabled || elementType === 'input' ? undefined : isDisabled,
      rel: elementType === 'a' ? rel : undefined
    };
  }

  let {
    pressProps,
    isPressed
  } = (0, $b75e7ed18f914c4039a9fb9f9d6c7a34$var$_interactions.usePress)({
    onPressStart,
    onPressEnd,
    onPressChange,
    onPress,
    isDisabled,
    ref
  });
  let {
    focusableProps
  } = (0, $b75e7ed18f914c4039a9fb9f9d6c7a34$var$_focus.useFocusable)(props, ref);
  let buttonProps = (0, $b75e7ed18f914c4039a9fb9f9d6c7a34$var$_utils.mergeProps)(focusableProps, pressProps);
  buttonProps = (0, $b75e7ed18f914c4039a9fb9f9d6c7a34$var$_utils.mergeProps)(buttonProps, (0, $b75e7ed18f914c4039a9fb9f9d6c7a34$var$_utils.filterDOMProps)(props, {
    labelable: true
  }));
  return {
    isPressed,
    // Used to indicate press state for visual
    buttonProps: (0, $b75e7ed18f914c4039a9fb9f9d6c7a34$var$_utils.mergeProps)(buttonProps, (0, $b75e7ed18f914c4039a9fb9f9d6c7a34$var$_extends2.default)({
      'aria-haspopup': props['aria-haspopup'],
      'aria-expanded': props['aria-expanded'],
      'aria-controls': props['aria-controls'],
      'aria-pressed': props['aria-pressed'],
      disabled: isDisabled,
      type
    }, additionalProps || {}, {
      onClick: e => {
        if (deprecatedOnClick) {
          deprecatedOnClick(e);
          console.warn('onClick is deprecated, please use onPress');
        }
      }
    }))
  };
}

Object.keys($b75e7ed18f914c4039a9fb9f9d6c7a34$exports).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return $b75e7ed18f914c4039a9fb9f9d6c7a34$exports[key];
    }
  });
});
// ASSET: /home/cong/Github/ladifire/ladifire-ui-react/packages/@react-ui-aria/button/src/useToggleButton.ts
var $d709d004d8cfa1cf1c11306c5e8659c7$exports = {};
var $d709d004d8cfa1cf1c11306c5e8659c7$var$_interopRequireDefault = _babelRuntimeHelpersInteropRequireDefault;
Object.defineProperty($d709d004d8cfa1cf1c11306c5e8659c7$exports, "__esModule", {
  value: true
});
var $d709d004d8cfa1cf1c11306c5e8659c7$export$useToggleButton = $d709d004d8cfa1cf1c11306c5e8659c7$var$useToggleButton;
$d709d004d8cfa1cf1c11306c5e8659c7$exports.useToggleButton = $d709d004d8cfa1cf1c11306c5e8659c7$export$useToggleButton;
var $d709d004d8cfa1cf1c11306c5e8659c7$var$_extends2 = $d709d004d8cfa1cf1c11306c5e8659c7$var$_interopRequireDefault(_babelRuntimeHelpersExtends);
var $d709d004d8cfa1cf1c11306c5e8659c7$var$_utils = _reactUiAriaUtils;

/**
 * Provides the behavior and accessibility implementation for a toggle button component.
 * ToggleButtons allow users to toggle a selection on or off, for example switching between two states or modes.
 */
function $d709d004d8cfa1cf1c11306c5e8659c7$var$useToggleButton(props, state, ref) {
  const {
    isSelected
  } = state;
  const {
    isPressed,
    buttonProps
  } = (0, $b75e7ed18f914c4039a9fb9f9d6c7a34$exports.useButton)((0, $d709d004d8cfa1cf1c11306c5e8659c7$var$_extends2.default)({}, props, {
    onPress: (0, $d709d004d8cfa1cf1c11306c5e8659c7$var$_utils.chain)(state.toggle, props.onPress)
  }), ref);
  return {
    isPressed,
    buttonProps: (0, $d709d004d8cfa1cf1c11306c5e8659c7$var$_utils.mergeProps)(buttonProps, {
      'aria-pressed': isSelected
    })
  };
}

Object.keys($d709d004d8cfa1cf1c11306c5e8659c7$exports).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return $d709d004d8cfa1cf1c11306c5e8659c7$exports[key];
    }
  });
});
//# sourceMappingURL=main.js.map
