import _reactUiAriaInteractions from "@react-ui-aria/interactions";
import _reactUiAriaFocus from "@react-ui-aria/focus";
import _reactUiAriaUtils from "@react-ui-aria/utils";
import _babelRuntimeHelpersEsmExtends from "@babel/runtime/helpers/esm/extends";
import _babelRuntimeHelpersInteropRequireDefault from "@babel/runtime/helpers/interopRequireDefault";
// ASSET: /home/cong/Github/ladifire/ladifire-ui-react/packages/@react-ui-aria/button/src/index.ts
var $d7d0e44de35b88e9c37f76739543d8$exports = {};
Object.defineProperty($d7d0e44de35b88e9c37f76739543d8$exports, "__esModule", {
  value: true
});
// ASSET: /home/cong/Github/ladifire/ladifire-ui-react/packages/@react-ui-aria/button/src/useButton.ts
var $b477fcedcecb3cd0990ca1e9677318$exports = {};
var $b477fcedcecb3cd0990ca1e9677318$var$_interopRequireDefault = _babelRuntimeHelpersInteropRequireDefault;
Object.defineProperty($b477fcedcecb3cd0990ca1e9677318$exports, "__esModule", {
  value: true
});
var $b477fcedcecb3cd0990ca1e9677318$export$useButton = $b477fcedcecb3cd0990ca1e9677318$var$useButton;
$b477fcedcecb3cd0990ca1e9677318$exports.useButton = $b477fcedcecb3cd0990ca1e9677318$export$useButton;
var $b477fcedcecb3cd0990ca1e9677318$var$_extends2 = $b477fcedcecb3cd0990ca1e9677318$var$_interopRequireDefault(_babelRuntimeHelpersEsmExtends);
var $b477fcedcecb3cd0990ca1e9677318$var$_utils = _reactUiAriaUtils;
var $b477fcedcecb3cd0990ca1e9677318$var$_focus = _reactUiAriaFocus;
var $b477fcedcecb3cd0990ca1e9677318$var$_interactions = _reactUiAriaInteractions;

/*
 * Copyright 2020 Ladifire. All rights reserved.
 * This file is licensed to you under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. You may obtain a copy
 * of the License at http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS
 * OF ANY KIND, either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */

/**
 * Provides the behavior and accessibility implementation for a button component. Handles mouse, keyboard, and touch interactions,
 * focus behavior, and ARIA props for both native button elements and custom element types.
 * @param props - Props to be applied to the button.
 * @param ref - A ref to a DOM element for the button.
 */
function $b477fcedcecb3cd0990ca1e9677318$var$useButton(props, ref) {
  let {
    elementType = 'button',
    isDisabled,
    onPress,
    onPressStart,
    onPressEnd,
    onPressChange,
    // @ts-ignore
    onClick: deprecatedOnClick,
    href,
    target,
    rel,
    type = 'button'
  } = props;
  let additionalProps;

  if (elementType !== 'button') {
    additionalProps = {
      role: 'button',
      tabIndex: isDisabled ? undefined : 0,
      href: elementType === 'a' && isDisabled ? undefined : href,
      target: elementType === 'a' ? target : undefined,
      type: elementType === 'input' ? type : undefined,
      disabled: elementType === 'input' ? isDisabled : undefined,
      'aria-disabled': !isDisabled || elementType === 'input' ? undefined : isDisabled,
      rel: elementType === 'a' ? rel : undefined
    };
  }

  let {
    pressProps,
    isPressed
  } = (0, $b477fcedcecb3cd0990ca1e9677318$var$_interactions.usePress)({
    onPressStart,
    onPressEnd,
    onPressChange,
    onPress,
    isDisabled,
    ref
  });
  let {
    focusableProps
  } = (0, $b477fcedcecb3cd0990ca1e9677318$var$_focus.useFocusable)(props, ref);
  let buttonProps = (0, $b477fcedcecb3cd0990ca1e9677318$var$_utils.mergeProps)(focusableProps, pressProps);
  buttonProps = (0, $b477fcedcecb3cd0990ca1e9677318$var$_utils.mergeProps)(buttonProps, (0, $b477fcedcecb3cd0990ca1e9677318$var$_utils.filterDOMProps)(props, {
    labelable: true
  }));
  return {
    isPressed,
    // Used to indicate press state for visual
    buttonProps: (0, $b477fcedcecb3cd0990ca1e9677318$var$_utils.mergeProps)(buttonProps, (0, $b477fcedcecb3cd0990ca1e9677318$var$_extends2.default)({
      'aria-haspopup': props['aria-haspopup'],
      'aria-expanded': props['aria-expanded'],
      'aria-controls': props['aria-controls'],
      'aria-pressed': props['aria-pressed'],
      disabled: isDisabled,
      type
    }, additionalProps || {}, {
      onClick: e => {
        if (deprecatedOnClick) {
          deprecatedOnClick(e);
          console.warn('onClick is deprecated, please use onPress');
        }
      }
    }))
  };
}

Object.keys($b477fcedcecb3cd0990ca1e9677318$exports).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty($d7d0e44de35b88e9c37f76739543d8$exports, key, {
    enumerable: true,
    get: function get() {
      return $b477fcedcecb3cd0990ca1e9677318$exports[key];
    }
  });
});
// ASSET: /home/cong/Github/ladifire/ladifire-ui-react/packages/@react-ui-aria/button/src/useToggleButton.ts
var $b069de289036199da574c613bc525ec2$exports = {};
var $b069de289036199da574c613bc525ec2$var$_interopRequireDefault = _babelRuntimeHelpersInteropRequireDefault;
Object.defineProperty($b069de289036199da574c613bc525ec2$exports, "__esModule", {
  value: true
});
var $b069de289036199da574c613bc525ec2$export$useToggleButton = $b069de289036199da574c613bc525ec2$var$useToggleButton;
$b069de289036199da574c613bc525ec2$exports.useToggleButton = $b069de289036199da574c613bc525ec2$export$useToggleButton;
var $b069de289036199da574c613bc525ec2$var$_extends2 = $b069de289036199da574c613bc525ec2$var$_interopRequireDefault(_babelRuntimeHelpersEsmExtends);
var $b069de289036199da574c613bc525ec2$var$_utils = _reactUiAriaUtils;

/**
 * Provides the behavior and accessibility implementation for a toggle button component.
 * ToggleButtons allow users to toggle a selection on or off, for example switching between two states or modes.
 */
function $b069de289036199da574c613bc525ec2$var$useToggleButton(props, state, ref) {
  const {
    isSelected
  } = state;
  const {
    isPressed,
    buttonProps
  } = (0, $b477fcedcecb3cd0990ca1e9677318$exports.useButton)((0, $b069de289036199da574c613bc525ec2$var$_extends2.default)({}, props, {
    onPress: (0, $b069de289036199da574c613bc525ec2$var$_utils.chain)(state.toggle, props.onPress)
  }), ref);
  return {
    isPressed,
    buttonProps: (0, $b069de289036199da574c613bc525ec2$var$_utils.mergeProps)(buttonProps, {
      'aria-pressed': isSelected
    })
  };
}

Object.keys($b069de289036199da574c613bc525ec2$exports).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty($d7d0e44de35b88e9c37f76739543d8$exports, key, {
    enumerable: true,
    get: function get() {
      return $b069de289036199da574c613bc525ec2$exports[key];
    }
  });
});
//# sourceMappingURL=module.js.map
